import { ChangeMap } from "./message";
export declare type HTMLColor = string;
export declare const DefaultEventOptions: {
    bubbles: boolean;
    composed: boolean;
    cancelable: boolean;
};
export declare class HPCCElement extends HTMLElement {
    static register(): void;
    static get observedAttributes(): string[];
    private $meta;
    private $dispatch;
    protected _fire: (what: string, oldVal?: any, newVal?: any) => void;
    private $dispatchHandle;
    private $styles;
    protected set styles(_: string);
    protected get styles(): string;
    constructor();
    private $upgradeProperties;
    protected coercedValue(qualifiedName: string, value: string | null): string | number | boolean | null;
    attr(qualifiedName: string): boolean | number | string | null;
    attr(qualifiedName: string, _: boolean | number | string | null): this;
    private $_initialized;
    private initalizeAttributes;
    connectedCallback(): void;
    disconnectedCallback(): void;
    adoptedCallback(): void;
    attributeChangedCallback(name: any, _oldValue: any, newValue: any): void;
    enter(): void;
    update(_changes: ChangeMap<this>): void;
    exit(): void;
    $emit(type: string, detail?: any, options?: any): boolean;
}
//# sourceMappingURL=element.d.ts.map